﻿#include 'hmg.ch'

FUNCTION Main()

  SET FONT TO 'MS Shell Dlg', 8

  DEFINE WINDOW MainWA;
    MAIN;
    WIDTH  270;
    HEIGHT 160;
    TITLE  'Speed test';
    NOMAXIMIZE;
    NOSIZE

    DEFINE LABEL CountLA
      ROW     10
      COL     10
      WIDTH   50
      HEIGHT  13
      VALUE  'Iterations:'
    END LABEL

    DEFINE TEXTBOX CountTE
      ROW            10
      COL            65
      WIDTH          50
      HEIGHT         20
      VALUE      100000
      DATATYPE   NUMERIC
      INPUTMASK  '999999'
      RIGHTALIGN .T.
    END TEXTBOX

    DEFINE BUTTON TestBU
      ROW      10
      COL     180
      WIDTH    70
      HEIGHT   23
      CAPTION '&Test'
      ACTION  Test()
    END BUTTON

    DEFINE LABEL Func1LA
      ROW     50
      COL     10
      WIDTH  180
      HEIGHT  13
      VALUE  '1. GetCompactPath (Grigory Filatov):'
    END LABEL

    DEFINE LABEL Test1LA
      ROW        50
      COL       195
      WIDTH      55
      HEIGHT     13
      ALIGNMENT RIGHT
      VALUE     ''
    END LABEL

    DEFINE LABEL Func2LA
      ROW     75
      COL     10
      WIDTH  180
      HEIGHT  13
      VALUE  '2. GetCompactPathChar_HMG (KDJ):'
    END LABEL

    DEFINE LABEL Test2LA
      ROW        75
      COL       195
      WIDTH      55
      HEIGHT     13
      ALIGNMENT RIGHT
      VALUE     ''
    END LABEL

    DEFINE LABEL Func3LA
      ROW    100
      COL     10
      WIDTH  180
      HEIGHT  13
      VALUE  '3. GetCompactPathChar_C (KDJ):'
    END LABEL

    DEFINE LABEL Test3LA
      ROW       100
      COL       195
      WIDTH      55
      HEIGHT     13
      ALIGNMENT RIGHT
      VALUE     ''
    END LABEL

    ON KEY ESCAPE ACTION MainWA.RELEASE

  END WINDOW

  MainWA.CENTER
  MainWA.ACTIVATE

RETURN NIL


FUNCTION Test()
  LOCAL nCount := MainWA.CountTE.VALUE
  LOCAL cFile  := GetProcessFullName()
  LOCAL nChars := 20
  LOCAL cShort := Space(nChars + 1)
  LOCAL nSec
  LOCAL n

  MainWA.TestBU.CAPTION := 'Wait...'
  MainWA.Test1LA.VALUE  := ''
  MainWA.Test2LA.VALUE  := ''
  MainWA.Test3LA.VALUE  := ''

  nSec := Seconds()

  FOR n := 1 TO nCount
    GetCompactPath(@cShort, cFile, nChars + 1, 0)
  NEXT

  MainWA.Test1LA.VALUE := Str((Seconds() - nSec) * 1000, 6) + ' ms'

  nSec := Seconds()

  FOR n := 1 TO nCount
    GetCompactPathChar_HMG(cFile, nChars)
  NEXT

  MainWA.Test2LA.VALUE := Str((Seconds() - nSec) * 1000, 6) + ' ms'

  nSec := Seconds()

  FOR n := 1 TO nCount
    GetCompactPathChar_C(cFile, nChars)
  NEXT

  MainWA.Test3LA.VALUE  := Str((Seconds() - nSec) * 1000, 6) + ' ms'
  MainWA.TestBU.CAPTION := '&Test'

RETURN NIL


FUNCTION GetCompactPathChar_HMG(cPath, nChars)
  LOCAL cPathComp

  IF ++nChars < 0
    nChars := 0
  ENDIF

  cPathComp := Space(nChars)

RETURN If(HMG_CallDLL('Shlwapi.dll', 0, 'PathCompactPathEx', @cPathComp, cPath, nChars, NIL) == 0, cPath, cPathComp)


#pragma BEGINDUMP
  #include "SET_COMPILE_HMG_UNICODE.ch"
  #include "HMG_UNICODE.h"

  #include <windows.h>
  #include <shlwapi.h>
  #include "hbapi.h"


          //GetCompactPathChar_C(cPath, nChars) -> cCompactPath
  HB_FUNC ( GETCOMPACTPATHCHAR_C )
  {
    LPCTSTR pszSrc = (LPCTSTR) HMG_parc(1);
    INT     ccMax  = (INT)     hb_parni(2) + 1;

    if (ccMax < 1)
      ccMax = 1;
    else if (ccMax > MAX_PATH)
      ccMax = MAX_PATH;

    TCHAR pszOut[ccMax];

    PathCompactPathEx(pszOut, pszSrc, ccMax, 0);

    HMG_retc(pszOut);
  }


  // Grigory Filatov <gfilatov@inbox.ru> HMG 1.1 Experimental Build 11a
  typedef INT ( WINAPI * _GETCOMPACTPATH )( LPTSTR pszOut, LPTSTR pszSrc, INT cchMax, DWORD dwFlags );

  HB_FUNC( GETCOMPACTPATH )
  {
     HINSTANCE handle = LoadLibrary( L"shlwapi.dll" );

     if( handle )
     {
        _GETCOMPACTPATH pFunc;
        pFunc = ( _GETCOMPACTPATH ) GetProcAddress( handle, "PathCompactPathExA" );
        hb_retni( pFunc( ( LPTSTR ) hb_parc( 1 ), ( LPTSTR ) hb_parc( 2 ), ( INT ) hb_parni( 3 ), ( DWORD ) hb_parnl( 4 ) ) );
        FreeLibrary( handle );
     }
  }

#pragma ENDDUMP
